/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
)

// checks if the MediaBudget type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &MediaBudget{}

// MediaBudget struct for MediaBudget
type MediaBudget struct {
	Id *string `json:"id,omitempty"`
	RolloutId *string `json:"rollout_id,omitempty"`
	OrganizationId *string `json:"organization_id,omitempty"`
	ChannelId *string `json:"channel_id,omitempty"`
	// decimal string
	Budget *string `json:"budget,omitempty"`
}

// NewMediaBudget instantiates a new MediaBudget object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewMediaBudget() *MediaBudget {
	this := MediaBudget{}
	return &this
}

// NewMediaBudgetWithDefaults instantiates a new MediaBudget object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewMediaBudgetWithDefaults() *MediaBudget {
	this := MediaBudget{}
	return &this
}

// GetId returns the Id field value if set, zero value otherwise.
func (o *MediaBudget) GetId() string {
	if o == nil || IsNil(o.Id) {
		var ret string
		return ret
	}
	return *o.Id
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MediaBudget) GetIdOk() (*string, bool) {
	if o == nil || IsNil(o.Id) {
		return nil, false
	}
	return o.Id, true
}

// HasId returns a boolean if a field has been set.
func (o *MediaBudget) HasId() bool {
	if o != nil && !IsNil(o.Id) {
		return true
	}

	return false
}

// SetId gets a reference to the given string and assigns it to the Id field.
func (o *MediaBudget) SetId(v string) {
	o.Id = &v
}

// GetRolloutId returns the RolloutId field value if set, zero value otherwise.
func (o *MediaBudget) GetRolloutId() string {
	if o == nil || IsNil(o.RolloutId) {
		var ret string
		return ret
	}
	return *o.RolloutId
}

// GetRolloutIdOk returns a tuple with the RolloutId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MediaBudget) GetRolloutIdOk() (*string, bool) {
	if o == nil || IsNil(o.RolloutId) {
		return nil, false
	}
	return o.RolloutId, true
}

// HasRolloutId returns a boolean if a field has been set.
func (o *MediaBudget) HasRolloutId() bool {
	if o != nil && !IsNil(o.RolloutId) {
		return true
	}

	return false
}

// SetRolloutId gets a reference to the given string and assigns it to the RolloutId field.
func (o *MediaBudget) SetRolloutId(v string) {
	o.RolloutId = &v
}

// GetOrganizationId returns the OrganizationId field value if set, zero value otherwise.
func (o *MediaBudget) GetOrganizationId() string {
	if o == nil || IsNil(o.OrganizationId) {
		var ret string
		return ret
	}
	return *o.OrganizationId
}

// GetOrganizationIdOk returns a tuple with the OrganizationId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MediaBudget) GetOrganizationIdOk() (*string, bool) {
	if o == nil || IsNil(o.OrganizationId) {
		return nil, false
	}
	return o.OrganizationId, true
}

// HasOrganizationId returns a boolean if a field has been set.
func (o *MediaBudget) HasOrganizationId() bool {
	if o != nil && !IsNil(o.OrganizationId) {
		return true
	}

	return false
}

// SetOrganizationId gets a reference to the given string and assigns it to the OrganizationId field.
func (o *MediaBudget) SetOrganizationId(v string) {
	o.OrganizationId = &v
}

// GetChannelId returns the ChannelId field value if set, zero value otherwise.
func (o *MediaBudget) GetChannelId() string {
	if o == nil || IsNil(o.ChannelId) {
		var ret string
		return ret
	}
	return *o.ChannelId
}

// GetChannelIdOk returns a tuple with the ChannelId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MediaBudget) GetChannelIdOk() (*string, bool) {
	if o == nil || IsNil(o.ChannelId) {
		return nil, false
	}
	return o.ChannelId, true
}

// HasChannelId returns a boolean if a field has been set.
func (o *MediaBudget) HasChannelId() bool {
	if o != nil && !IsNil(o.ChannelId) {
		return true
	}

	return false
}

// SetChannelId gets a reference to the given string and assigns it to the ChannelId field.
func (o *MediaBudget) SetChannelId(v string) {
	o.ChannelId = &v
}

// GetBudget returns the Budget field value if set, zero value otherwise.
func (o *MediaBudget) GetBudget() string {
	if o == nil || IsNil(o.Budget) {
		var ret string
		return ret
	}
	return *o.Budget
}

// GetBudgetOk returns a tuple with the Budget field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MediaBudget) GetBudgetOk() (*string, bool) {
	if o == nil || IsNil(o.Budget) {
		return nil, false
	}
	return o.Budget, true
}

// HasBudget returns a boolean if a field has been set.
func (o *MediaBudget) HasBudget() bool {
	if o != nil && !IsNil(o.Budget) {
		return true
	}

	return false
}

// SetBudget gets a reference to the given string and assigns it to the Budget field.
func (o *MediaBudget) SetBudget(v string) {
	o.Budget = &v
}

func (o MediaBudget) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o MediaBudget) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Id) {
		toSerialize["id"] = o.Id
	}
	if !IsNil(o.RolloutId) {
		toSerialize["rollout_id"] = o.RolloutId
	}
	if !IsNil(o.OrganizationId) {
		toSerialize["organization_id"] = o.OrganizationId
	}
	if !IsNil(o.ChannelId) {
		toSerialize["channel_id"] = o.ChannelId
	}
	if !IsNil(o.Budget) {
		toSerialize["budget"] = o.Budget
	}
	return toSerialize, nil
}

type NullableMediaBudget struct {
	value *MediaBudget
	isSet bool
}

func (v NullableMediaBudget) Get() *MediaBudget {
	return v.value
}

func (v *NullableMediaBudget) Set(val *MediaBudget) {
	v.value = val
	v.isSet = true
}

func (v NullableMediaBudget) IsSet() bool {
	return v.isSet
}

func (v *NullableMediaBudget) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableMediaBudget(val *MediaBudget) *NullableMediaBudget {
	return &NullableMediaBudget{value: val, isSet: true}
}

func (v NullableMediaBudget) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableMediaBudget) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


